2018.1.29【 CodeForces - 455A 】解题报告(dp,long long)

A. Boredom
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Alex doesn't like boredom. That's why whenever he gets bored, he comes up with games. One long winter evening he came up with a game and decided to play it.

Given a sequence a consisting of n integers. The player can make several steps. In a single step he can choose an element of the sequence (let's denote it ak) and delete it, at that all elements equal to ak + 1 and ak - 1 also must be deleted from the sequence. That step brings ak points to the player.

Alex is a perfectionist, so he decided to get as many points as possible. Help him.

Input

The first line contains integer n (1 ≤ n ≤ 105) that shows how many numbers are in Alex's sequence.

The second line contains n integers a1a2, ..., an (1 ≤ ai ≤ 105).

Output

Print a single integer — the maximum number of points that Alex can earn.

Examples
input
2
1 2
output
2
input
3
1 2 3
output
4
input
9
1 2 1 3 2 2 2 2 3
output
10
Note

Consider the third test example. At first step we need to choose any element equal to 2. After that step our sequence looks like this [2, 2, 2, 2]. Then we do 4 steps, on each step we choose any element equals to 2. In total we earn 10 points.

【题目大意】

给出一个数列a1,a2,a3...ai...an。每次选定一个数ai,并且所有与ai-1,ai+1相等的数全部消去,这样消去一次得分为ai。最终把数列全部消去完,问最终最高得分是多少。

【解题思路】

dp,数组A[ai]表示ai出现的次数,并且记录最大值mmax,从0到mmax走一遍dp。

状态转移方程为dp[i]=max(dp[i-1],dp[i-2]+A[i]*i),即从小到大消去到ai=i时的最高得分为:消去到i-1的最高得分(因为消去i-1时所有i=i-1+1全部被消去)与消去到i-2的最高得分加上消去A[i]个i的得分(即跳过i-1不消去)。

由于涉及求和,ai乘上出现次数会超int范围,故使用long long。

【解题代码】

#include <queue>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <algorithm>
//dp[i]=max(dp[i-1],dp[i-2]+a[i]*i)
using namespace std;
const int maxn=100100;
long long dp[maxn],a[maxn];
long long n,t,mmax;
void solve()
{
	//0不出现,初始化 1 
	dp[1]=a[1];
	for(long long i=2;i<=mmax;i++)
	{
		dp[i]=max(dp[i-1],dp[i-2]+a[i]*i);
	}
	printf("%lld\n",dp[mmax]);
}
int main()
{
	while(~scanf("%lld",&n))
	{
		memset(dp,0,sizeof(dp));
		memset(a,0,sizeof(a));
		long long maxx=0;
		for(long long i=1;i<=n;i++)
		{
			scanf("%lld",&t);
			if(t>mmax) mmax=t;
			a[t]++;
		}
//		for(long long i=1;i<=n;i++)
//			printf("a[%d]=%d\n",i,a[i]);
		solve();
	}
	return 0;
}

【收获与反思】

建立好状态转移方程就好,注意long long。


引用\[1\]中提到了一种树形动态规划的方法来解决CodeForces - 982C问题。在这个问题中,subtree指的是子连通块,而不是子树。为了使cnt_white - cnt_black尽可能大,可以使用两次树形动态规划来求解。第一次是自底向上的过程,维护一个dp数组,表示以每个节点为根的子树中的最大连通块。第二次是自顶向下的过程,处理自底向上过程中无法包含的树链所代表的子树。在第二次遍历中,需要维护一个sum变量,用于存储树链所代表的子树的贡献。根据ans\[u\]的正负,决定是否能对相邻的子节点做出贡献。如果ans\[u\]为正,则减去dp\[v\]就是树链所代表的子树的权值。最终,ans\[u\]代表包含节点u在内的子连通块的最大权值。\[1\] 问题: CodeForces - 982C 树形DP是什么问题?如何解决? 回答: CodeForces - 982C是一个树形动态规划问题。在这个问题中,需要求解子连通块的最大权值和,使得cnt_white - cnt_black尽可能大。解决这个问题的方法是使用两次树形动态规划。第一次是自底向上的过程,维护一个dp数组,表示以每个节点为根的子树中的最大连通块。第二次是自顶向下的过程,处理自底向上过程中无法包含的树链所代表的子树。在第二次遍历中,需要维护一个sum变量,用于存储树链所代表的子树的贡献。根据ans\[u\]的正负,决定是否能对相邻的子节点做出贡献。最终,ans\[u\]代表包含节点u在内的子连通块的最大权值。\[1\] #### 引用[.reference_title] - *1* *2* [CodeForces - 1324F Maximum White Subtree(树形dp)](https://blog.csdn.net/qq_45458915/article/details/104831678)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值